/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.jiuqi.util.Matrix
 *  com.jiuqi.util.Stream
 *  com.jiuqi.util.StreamException
 */
package com.jiuqi.grid;

import com.jiuqi.grid.CellField;
import com.jiuqi.grid.GridCell;
import com.jiuqi.grid.GridData;
import com.jiuqi.util.Matrix;
import com.jiuqi.util.Stream;
import com.jiuqi.util.StreamException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

public final class GridFieldList
implements Serializable {
    private List list;
    private GridData parent;
    private boolean autoMerge;
    private Matrix rectMaps;
    private Set tmpRects;

    public GridFieldList(GridData aParent) {
        this();
        this.parent = aParent;
    }

    public GridFieldList() {
        Comparator rectCmp = new Comparator(){

            public int compare(Object o1, Object o2) {
                CellField f1 = (CellField)o1;
                CellField f2 = (CellField)o2;
                return f1.compareTo(f2);
            }
        };
        this.list = new ArrayList();
        this.rectMaps = new Matrix();
        this.tmpRects = new TreeSet(rectCmp);
    }

    public int count() {
        return this.list.size();
    }

    public GridData getParent() {
        return this.parent;
    }

    public CellField get(int index) {
        return (CellField)this.list.get(index);
    }

    public void remove(int index) {
        CellField field = (CellField)this.list.remove(index);
        int col = field.left;
        while (col <= field.right) {
            int row = field.top;
            while (row <= field.bottom) {
                this.rectMaps.setItem(col, row, null);
                ++row;
            }
            ++col;
        }
    }

    protected boolean remove(CellField field) {
        int i = 0;
        while (i < this.list.size()) {
            if (field == this.list.get(i)) {
                this.remove(i);
                return true;
            }
            ++i;
        }
        return false;
    }

    public CellField getMergeRect(int col, int row) {
        if (col >= this.rectMaps.getColCount() || row >= this.rectMaps.getRowCount()) {
            return null;
        }
        return (CellField)this.rectMaps.getItem(col, row);
    }

    public boolean checkCanMerge(CellField field) {
        int col = field.left;
        while (col <= field.right) {
            int row = field.top;
            while (row <= field.bottom) {
                CellField f = this.getMergeRect(col, row);
                if (f != null) {
                    switch (CellField.compareField(f, field)) {
                        case -2: 
                        case 1: {
                            return false;
                        }
                    }
                }
                ++row;
            }
            ++col;
        }
        return true;
    }

    public boolean addMergeRect(CellField field) {
        if (this.checkCanMerge(field)) {
            this.tmpRects.clear();
            if (this.rectMaps.getColCount() <= field.right) {
                this.rectMaps.setColCount(field.right + 1);
            }
            if (this.rectMaps.getRowCount() <= field.bottom) {
                this.rectMaps.setRowCount(field.bottom + 1);
            }
            int col = field.left;
            while (col <= field.right) {
                int row = field.top;
                while (row <= field.bottom) {
                    CellField f = (CellField)this.rectMaps.getItem(col, row);
                    if (f != null && !this.tmpRects.contains(f)) {
                        this.tmpRects.add(f);
                    }
                    this.rectMaps.setItem(col, row, (Object)field);
                    ++row;
                }
                ++col;
            }
            if (!this.tmpRects.isEmpty()) {
                this.list.removeAll(this.tmpRects);
                this.tmpRects.clear();
            }
            this.list.add(field);
            return true;
        }
        return false;
    }

    public int removeMergeRect(CellField field) {
        int count = 0;
        int col = field.left;
        while (col <= field.right) {
            int row = field.top;
            while (row <= field.bottom) {
                CellField f = this.getMergeRect(col, row);
                if (f != null) {
                    if (field.containField(f)) {
                        this.remove(f);
                        ++count;
                    } else {
                        GridCell originCell = this.parent.getCellEx(f.left, f.top);
                        if (f.left <= field.right && f.right > field.right) {
                            f.left = field.right + 1;
                        }
                        if (f.top <= field.bottom && f.bottom > field.bottom) {
                            f.top = field.bottom + 1;
                        }
                        GridCell currentCell = this.parent.getCellEx(f.left, f.top);
                        if (originCell != null && currentCell != null && !originCell.equals(currentCell)) {
                            currentCell.setBackColor(originCell.getBackColor());
                            currentCell.setBackStyle(originCell.getBackStyle());
                            currentCell.setLEdgeStyle(originCell.getLEdgeStyle());
                            currentCell.setLEdgeColor(originCell.getLEdgeColor());
                            currentCell.setTEdgeStyle(originCell.getTEdgeStyle());
                            currentCell.setTEdgeColor(originCell.getTEdgeColor());
                            currentCell.setREdgeStyle(originCell.getREdgeStyle());
                            currentCell.setREdgeColor(originCell.getREdgeColor());
                            currentCell.setBEdgeStyle(originCell.getBEdgeStyle());
                            currentCell.setBEdgeColor(originCell.getBEdgeColor());
                            currentCell.setShowText("");
                            this.parent.setCell(currentCell);
                        }
                    }
                }
                ++row;
            }
            ++col;
        }
        return count;
    }

    public void delRows(int startRow, int count) {
        int top = startRow;
        int bottom = startRow + count - 1;
        int i = this.count() - 1;
        while (i >= 0) {
            int b;
            CellField f = this.get(i);
            int t = f.top < top ? top : f.top;
            int n = b = f.bottom < bottom ? f.bottom : bottom;
            if (b >= t) {
                f.bottom -= b - t + 1;
                if (f.bottom < f.top) {
                    this.remove(i);
                }
            } else if (f.top > bottom) {
                f.top -= count;
                f.bottom -= count;
            }
            --i;
        }
        if (startRow < this.rectMaps.getRowCount()) {
            this.rectMaps.deleteRow(startRow, count);
        }
    }

    public void delCols(int startCol, int count) {
        int left = startCol;
        int right = startCol + count - 1;
        int i = this.count() - 1;
        while (i >= 0) {
            int r;
            CellField f = this.get(i);
            int l = f.left < left ? left : f.left;
            int n = r = f.right < right ? f.right : right;
            if (r >= l) {
                f.right -= r - l + 1;
            }
            if (f.right < f.left) {
                this.remove(i);
            } else if (f.left > right) {
                f.left -= count;
                f.right -= count;
            }
            --i;
        }
        if (startCol < this.rectMaps.getColCount()) {
            this.rectMaps.deleteCol(startCol, count);
        }
    }

    public void insertRows(int startRow, int count) {
        CellField f;
        Object[] colItems = null;
        ArrayList<CellField> adjRects = new ArrayList<CellField>();
        int i = 0;
        while (i < this.count()) {
            f = this.get(i);
            if (startRow > f.top && startRow <= f.bottom) {
                f.bottom += count;
                if (colItems == null) {
                    colItems = new Object[this.rectMaps.getColCount()];
                }
                int col = f.left;
                while (col <= f.right) {
                    colItems[col] = f;
                    ++col;
                }
            } else if (startRow <= f.top) {
                f.top += count;
                f.bottom += count;
            } else if (startRow == f.bottom + 1 && f.right > f.left && this.autoMerge) {
                adjRects.add(f);
            }
            ++i;
        }
        if (this.rectMaps.getRowCount() > 0 && startRow <= this.rectMaps.getRowCount()) {
            this.rectMaps.insertRow(startRow, count, colItems);
        }
        i = 0;
        while (i < adjRects.size()) {
            f = (CellField)adjRects.get(i);
            int row = startRow;
            while (row < startRow + count) {
                this.addMergeRect(new CellField(f.left, row, f.right, row));
                ++row;
            }
            ++i;
        }
    }

    public void insertCols(int startCol, int count) {
        CellField f;
        Object[] rowItems = null;
        ArrayList<CellField> adjRects = new ArrayList<CellField>();
        int i = 0;
        while (i < this.count()) {
            f = this.get(i);
            if (startCol > f.left && startCol <= f.right) {
                f.right += count;
                if (rowItems == null) {
                    rowItems = new Object[this.rectMaps.getRowCount()];
                }
                int row = f.top;
                while (row <= f.bottom) {
                    rowItems[row] = f;
                    ++row;
                }
            } else if (startCol <= f.left) {
                f.left += count;
                f.right += count;
            } else if (startCol == f.right + 1 && f.top < f.bottom && this.autoMerge) {
                adjRects.add(f);
            }
            ++i;
        }
        if (this.rectMaps.getColCount() > 0 && startCol <= this.rectMaps.getColCount()) {
            this.rectMaps.insertCol(startCol, count, rowItems);
        }
        i = 0;
        while (i < adjRects.size()) {
            f = (CellField)adjRects.get(i);
            int col = startCol;
            while (col < startCol + count) {
                this.addMergeRect(new CellField(col, f.top, col, f.bottom));
                ++col;
            }
            ++i;
        }
    }

    public void extendRows(int startRow, int count) {
        int i = 0;
        while (i < this.count()) {
            CellField f = this.get(i);
            if (startRow >= f.top && startRow <= f.bottom) {
                f.bottom += count;
            } else if (startRow < f.top) {
                f.top += count;
                f.bottom += count;
            }
            ++i;
        }
        if (this.rectMaps.getRowCount() > 0 && startRow < this.rectMaps.getRowCount()) {
            this.rectMaps.duplicateRow(startRow, count);
        }
    }

    public void extendCols(int startCol, int count) {
        int i = 0;
        while (i < this.count()) {
            CellField f = this.get(i);
            if (startCol >= f.left && startCol <= f.right) {
                f.right += count;
            } else if (startCol < f.left) {
                f.left += count;
                f.right += count;
            }
            ++i;
        }
        if (this.rectMaps.getColCount() > 0 && startCol < this.rectMaps.getColCount()) {
            this.rectMaps.duplicateCol(startCol, count);
        }
    }

    public List findFieldsInCols(int from, int to) {
        ArrayList<CellField> result = new ArrayList<CellField>();
        int i = 0;
        while (i < this.count()) {
            CellField f = this.get(i);
            if (f.left >= from && f.right <= to) {
                result.add(f);
            }
            ++i;
        }
        return result;
    }

    public List findFieldsInRows(int from, int to) {
        ArrayList<CellField> result = new ArrayList<CellField>();
        int i = 0;
        while (i < this.count()) {
            CellField f = this.get(i);
            if (f.top >= from && f.bottom <= to) {
                result.add(f);
            }
            ++i;
        }
        return result;
    }

    public void loadFromStream(Stream stream, int size) throws StreamException {
        this.list.clear();
        this.rectMaps.clear();
        int i = 0;
        while (i < size / 16) {
            CellField cf = new CellField();
            cf.left = stream.readInt();
            cf.top = stream.readInt();
            cf.right = stream.readInt();
            cf.bottom = stream.readInt();
            this.addMergeRect(cf);
            ++i;
        }
    }

    public void saveToStream(Stream stream) throws StreamException {
        int i = 0;
        while (i < this.list.size()) {
            CellField cf = (CellField)this.list.get(i);
            stream.writeInt(cf.left);
            stream.writeInt(cf.top);
            stream.writeInt(cf.right);
            stream.writeInt(cf.bottom);
            ++i;
        }
    }

    public boolean getAutoMerge() {
        return this.autoMerge;
    }

    public void setAutoMerge(boolean value) {
        this.autoMerge = value;
    }
}

